 
      SUBROUTINE DensArray
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c MultiWell: a code for chemical kinetics calculations.
c Copyright (C) 2008 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c	Generates densities of states in 'double' array
c
c	Options: Whitten-Rabinovitch, or read densities from external file
c
c	SMol = 0 : A product molecule and do not calculate densities
c
c	Note that File name and path in OPEN statements may need revision
c		for non-Macintosh
c
c***********************************************************************
      IMPLICIT NONE
      INCLUDE 'declare1.inc'
      INTEGER i , II , JJ , j , k , lenstr
      DOUBLE PRECISION E , D , WRSUM , A , B , Test1 , Test2
      CHARACTER TITLE*100
      EXTERNAL lenstr
      SAVE  
 
 
      DO 100 i = 1 , NWells
         Viblo(i) = 100.                        ! lowest vibrational frequency
            OPEN (12,FILE='DensData/'//
     &      MolName(i)(1:lenstr(MolName(i)))//'.dens',STATUS='OLD')

            READ (12,99030) dumcut                 ! Check to see if file format includes input data summary
            IF ( dumcut .EQ. cut ) THEN            ! Format starting with v.2008.1
               dumcut = 'x'
               DO WHILE (dumcut .NE. cut)
                 READ (12,99030) dumcut
               END DO
            ELSE
               BACKSPACE 12                        ! If format from prior to v.2008.1
            ENDIF
99030 FORMAT (A46)

            READ (12,*) TITLE
            READ (12,*) TITLE
            READ (12,*) A , JJ , B , k , Viblo(i)
            READ (12,*) TITLE
            Test1 = ABS(A-Egrain1)/1.D-06
            Test2 = ABS(B-Emax2)/1.D-06
            IF ( Test1.LT.1.0 .AND. JJ.EQ.imax1 .AND. Test2.LT.1.0 .AND. 
     &           k.EQ.Isize ) THEN              ! Test for proper array bounds, etc.
               DO 10 k = 1 , Isize
                  READ (12,*) j , A , Dens(i,k) , B
                  IF ( Dens(i,k).GT.0.0 ) THEN
                     Dens(i,k) = LOG(Dens(i,k)) ! Store natural log.
                  ELSE
                     Dens(i,k) = -70.
                  ENDIF
 10            CONTINUE
            ELSE                        ! If grain or energy limit does not match
               WRITE (KSTD,99002) MolName(i)
               STOP
            ENDIF
            CLOSE (12)
 100  CONTINUE
 
      RETURN
 
99001 FORMAT (A100)
99002 FORMAT (/'Energy grain or energy limit does not match: ',
     &        A10/'****** FATAL ERROR: Run Terminated *******')

      END
