**==doubnterp.spg  processed by SPAG 5.11R  at 20:12 on 26 Mar 2001
      DOUBLE PRECISION FUNCTION DOUBNTERP(E,Mol,ARRAY)
 
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
c
c MultiWell: a code for chemical kinetics calculations.
c Copyright (C) 2001 John R. Barker
c
c John R. Barker
c jrbarker@umich.edu
c University of Michigan
c Ann Arbor, MI 48109-2143
c (734) 763 6239
c
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License (version 2)
c as published by the Free Software Foundation.
c
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
c GNU General Public License for more details.
c
c See the 'ReadMe' file for a copy of the GNU General Public License,
c or contact:
c
c Free Software Foundation, Inc.
c 59 Temple Place - Suite 330
c Boston, MA 02111-1307, USA.
c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
c
c	Interpolates 2-Dim double array ARRAY to determine
c		interpolated value at energy E.
c
      IMPLICIT NONE
      INCLUDE 'declare1.inc'
      INTEGER IE , Mol
      DOUBLE PRECISION E , X , DD , ARRAY(MaxWell,Imax) , y1 , y2 , y3
      SAVE 
 
       IF ( E.LE.Emax1 ) THEN
         IE = 1 + INT(E/Egrain1)
         IF (IE .LT. 1) IE = 1
         IF (IE .GT. Imax1) IE = Imax1
         DD = ARRAY(Mol,IE)
       ELSE
         CALL NTERP(E,IE,X)
         IF ( ABS(X) .LE. 1.D-06 ) THEN
           DD = ARRAY(Mol,IE)
         ELSE
           y1 = ARRAY(Mol,IE-1)
           y2 = ARRAY(Mol,IE)
           y3 = ARRAY(Mol,IE+1)
           CALL QUDINT(y1,y2,y3,X,DD)
         ENDIF
      ENDIF
      DOUBNTERP = DD

      RETURN
      END
